
#ifndef __DRIVER_VISION_H
#define __DRIVER_VISION_H


#include "stm32f4xx.h"
#include "OSinclude.h"
#include "CommonDataStructure.h"


#define PCDATALENGTH            26  //֡
#define ENEMYDATABUFFERLENGHT   60 //֡
#define FITDATANUMMIN           8   //С


#ifdef  __DRIVER_VISION_GLOBALS
#define __DRIVER_VISION_EXT 
#else
#define __DRIVER_VISION_EXT extern
#endif




//PCָö
typedef enum
{
    PCOrder_Attack,
    PCOrder_BigSample,
    PCOrder_Shutdown
}PCOrder_Enum;


//Ӿݽṹ
typedef struct
{
    float X;
    float Y;
    float Z;
    float TimeStamp;
    int Time;
    char ID;
    portTickType Tick;
}Enemy_Struct;

//ݽṹ
typedef struct
{
    float X;
    float Y;
    float Z;
}Point_Struct;

//ݽṹ(ʵʽǶȣ
typedef struct
{
    float H;
    float V;
}AngleF_Struct;

//ݽṹ(ڱǶȣ
typedef struct
{
    int16_t H;
    int16_t V;
}AngleI_Struct;

//Ԥпݽṹ
typedef struct
{
    AngleI_Struct Target;       //ĿǶȣλмΪ0Ҹ
    portTickType TargetTick;         //ڴ˾ʱ䵽ĿǶ
}ForcastControl_Struct;


//ԭʼݻ
__DRIVER_VISION_EXT uint8_t PCDataBuffer[PCDATALENGTH];
//ԭʼݻָ
__DRIVER_VISION_EXT uint8_t PCDataBufferPoint;
//ݻ
__DRIVER_VISION_EXT Enemy_Struct EnemyDataBuffer[ENEMYDATABUFFERLENGHT];
//ݻָ
__DRIVER_VISION_EXT uint8_t EnemyDataBufferPoint;
//ԤĿ
__DRIVER_VISION_EXT ForcastControl_Struct ForcastTarget;
//ݸ±־
__DRIVER_VISION_EXT uint8_t VisionUpdataFlag;

#if INFANTRY == 7
//Ŀɫ
__DRIVER_VISION_EXT int8_t PCVisionTargetColor;         //-1 δȷ        0          1 
#endif

//֡ͳ
__DRIVER_VISION_EXT int16_t PCFrameCounter;
//֡ͳ
__DRIVER_VISION_EXT int16_t PCFrameRate;


extern const uint8_t AttackModeOrder[PCDATALENGTH];
extern const uint8_t BigSymbolModeOrder[PCDATALENGTH];
extern const uint8_t ShutdownOrder[PCDATALENGTH];
    

void Vision_InitConfig(void);
AngleF_Struct RecToPolar(float X, float Y, float Z, float RealPitch, uint16_t PitchEncoder, uint8_t mode);
uint8_t ForcastCore(uint16_t SampleTime, uint16_t ForcastTime, Point_Struct *ForcastPoint);
uint8_t ForcastOnce(uint16_t SampleTime, uint16_t ForcastTime, AngleF_Struct *ForcastAngle, uint8_t TimeMode);
void SendPCOrder(PCOrder_Enum order);
void SendEnemyColor(char Co);


#endif
