
#define  __DBUS_GLOBALS

#include "Driver_DBUS.h"


#define ClearShackTick      50      //ʱ
    
    

/**
  * @brief  DBUSʼ
  * @param  void
  * @retval void
  */
void DBUS_InitConfig(void)
{
	DBUSConnectStatus = Lost;
	DBUSFrameRate = 0;
	DBUSFrameCounter = 0;
	DBUS_ReceiveData.ch1 = 0;
	DBUS_ReceiveData.ch2 = 0;
	DBUS_ReceiveData.ch3 = 0;
	DBUS_ReceiveData.ch4 = 0;
    DBUS_ReceiveData.keyBoard.key_code = 0;
    DBUS_ReceiveData.keyBoard.jumpkey_code = 0;
}


/**
  * @brief  DBUSݽ
  * @param  void
  * @retval void
  */
void DBUS_DataDecoding(void)
{
	LASTDBUS_ReceiveData = DBUS_ReceiveData;
	
	DBUS_ReceiveData.ch1 = (DBUSBuffer[0] | DBUSBuffer[1]<<8) & 0x07FF;
	DBUS_ReceiveData.ch1 -= 1024;
	DBUS_ReceiveData.ch2 = (DBUSBuffer[1]>>3 | DBUSBuffer[2]<<5 ) & 0x07FF;
	DBUS_ReceiveData.ch2 -= 1024;
	DBUS_ReceiveData.ch3 = (DBUSBuffer[2]>>6 | DBUSBuffer[3]<<2 | DBUSBuffer[4]<<10) & 0x07FF;
	DBUS_ReceiveData.ch3 -= 1024;
	DBUS_ReceiveData.ch4 = (DBUSBuffer[4]>>1 | DBUSBuffer[5]<<7) & 0x07FF;		
	DBUS_ReceiveData.ch4 -= 1024;
	
	DBUS_ReceiveData.switch_left = ( (DBUSBuffer[5] >> 4)& 0x000C ) >> 2;
	DBUS_ReceiveData.switch_right =  (DBUSBuffer[5] >> 4)& 0x0003 ;
	
	DBUS_ReceiveData.mouse.x = DBUSBuffer[6] | (DBUSBuffer[7] << 8);	//x axis
	DBUS_ReceiveData.mouse.y = DBUSBuffer[8] | (DBUSBuffer[9] << 8);
	DBUS_ReceiveData.mouse.z = DBUSBuffer[10]| (DBUSBuffer[11] << 8);
	
	DBUS_ReceiveData.mouse.press_left 	= DBUSBuffer[12];	// is pressed?
	DBUS_ReceiveData.mouse.press_right 	= DBUSBuffer[13];
	
	DBUS_ReceiveData.keyBoard.key_code 	= DBUSBuffer[14] | DBUSBuffer[15] << 8; //key borad code
}


/**
  * @brief  
  * @param  ǰϵͳʱ
  * @retval void
  */
void DBUS_ButtonCheckJump(portTickType CurrentTick)
{
    uint8_t index;
    
    //ϴζӦʱϵͳʱ
    static portTickType LastButtonJumpTick[15] = {0, 0, 0, 0, 0,
                                            0, 0, 0, 0, 0,
                                            0, 0, 0, 0, 0};
    static portTickType LastMouseButtonJumpTick[2] = {0, 0};
    
    for(index = 0; index < 15; index++)
    {
        if(CurrentTick - LastButtonJumpTick[index] >= ClearShackTick)
        {
            if((DBUS_ReceiveData.keyBoard.key_code & (1 << index)) && (!(LASTDBUS_ReceiveData.keyBoard.key_code & (1 << index))))
            {
                DBUS_ReceiveData.keyBoard.jumpkey_code |= 1 << index;
                LastButtonJumpTick[index] = CurrentTick;
            }
        }
        else
        {
            DBUS_ReceiveData.keyBoard.jumpkey_code &= ~(1 << index);
        }
    }
    
    if(CurrentTick - LastMouseButtonJumpTick[0] >= ClearShackTick)
    {
        if((DBUS_ReceiveData.mouse.press_left) && (!(LASTDBUS_ReceiveData.mouse.press_left)))
        {
            DBUS_ReceiveData.mouse.jumppress_left = 1;
            LastMouseButtonJumpTick[0] = CurrentTick;
        }
        else
        {
            DBUS_ReceiveData.mouse.jumppress_left = 0;
        }
    }
    else
    {
        DBUS_ReceiveData.mouse.jumppress_left = 0;
    }
    
    if(CurrentTick - LastMouseButtonJumpTick[1] >= ClearShackTick)
    {
        if((DBUS_ReceiveData.mouse.press_right) && (!(LASTDBUS_ReceiveData.mouse.press_right)))
        {
            DBUS_ReceiveData.mouse.jumppress_right = 1;
            LastMouseButtonJumpTick[0] = CurrentTick;
        }
        else
        {
            DBUS_ReceiveData.mouse.jumppress_right = 0;
        }
    }
    else
    {
        DBUS_ReceiveData.mouse.jumppress_right = 0;
    }
}


/**
  * @brief  жһǷ񱻰
  * @param  Ҫжϵİַд
  * @retval 1         0 δ
  */
uint8_t DBUS_CheckPush(uint16_t Key)
{
    if(DBUS_ReceiveData.keyBoard.key_code & Key)
    {
        return 1;
    }
    else
    {
        return 0;
    }
}


/**
  * @brief  жһ̼Ƿ
  * @param  Ҫжϵİַд
  * @retval 1         0 δ
  */
uint8_t DBUS_CheckJumpKey(uint16_t Key)
{
    if(DBUS_ReceiveData.keyBoard.jumpkey_code & Key)
    {
        return 1;
    }
    else
    {
        return 0;
    }
}


/**
  * @brief  жһǷ
  * @param  Ҫжϵİַд
  * @retval 1         0 δ
  */
uint8_t DBUS_CheckJumpMouse(uint8_t Key)
{
    if(Key)
    {
        return DBUS_ReceiveData.mouse.jumppress_left;
    }
    else
    {
        return DBUS_ReceiveData.mouse.jumppress_right;
    }
}




